SystemOrganization addCategory: #'TP2-Parte3'!

Object subclass: #AplicarUnaFuncion
	instanceVariableNames: 'funcion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!AplicarUnaFuncion class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:59'!
CrearEstrategiaCon: unaFuncion
	
	|nuevaEstrategia|
	
	nuevaEstrategia := AplicarUnaFuncion new.
	nuevaEstrategia funcion: unaFuncion.
	^nuevaEstrategia.! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 22:05'!
aplicarFuncion: unValor
	^self funcion unValor.! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:25'!
argumentosDe: codigo
	
	| palabrasPrimeraLinea |
	
	palabrasPrimeraLinea := (codigo lineCorrespondingToIndex: 1) substrings.
	
	^palabrasPrimeraLinea reject: [ :palabra | palabra endsWith: ':'].! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:25'!
armarWithsDe: argumentos
	
	^ (argumentos collect: [ :argumento  | 'with: ' ,argumento  ] ) inject: '' into: [ :frase :argumento | frase,' ',argumento ].! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:59'!
funcion
	^funcion ! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 22:10'!
funcion: unaFuncion
	funcion := unaFuncion. "Una funcion es un compiled method"! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:25'!
obtenerTraitsConflictivosEn: unaClase para: unMetodo

	| traitConflictivos |
	
	traitConflictivos  := Set new.
	
	traitConflictivos addAll: ( unaClase traits select: [ :trait | self tieneUnMetodoConflictivo: unMetodo en: trait ] ).	
	
	^traitConflictivos! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 22:04'!
resolverConflictoPara: unMetodo entre: unTrait y: unaClase

	| codigoOriginal conflictivos withsArmados |
	
	( unaClase selectors includes: ('original',unMetodo ) ) ifFalse: 
	[
		codigoOriginal := (unaClase >> unMetodo) sourceCode.
	
		withsArmados := (EjecutarTodasEnOrden new) armarWithsDe: (self argumentosDe: codigoOriginal).

		unaClase compile: 'original',codigoOriginal.
	
		unaClase compile:
		( (unaClase >> unMetodo) sourceCode lineCorrespondingToIndex: 1),'
			| conflictivos retorno argumentos refactor|
			
			refactor := ',self,'
	
			argumentos := (EjecutarTodasEnOrden new) argumentosDe: ( (self class >> #original',unMetodo,' ) sourceCode ).
		
			conflictivos := ( (EjecutarTodasEnOrden new) obtenerTraitsConflictivosEn: self class para: #',unMetodo,' ). 
		
			retorno := self perform: #original',unMetodo,' ',withsArmados,'.
		
			retorno := conflictivos inject: retorno into: [ :resultado :implementador | (self class) methodDict at: #auxiliar put: (implementador >> #',unMetodo,') . 
				     																	    self perform: #auxiliar with: resultado ].
			(self class) methodDict at: #auxiliar put: nil.
		
			^refactor retorno.
			'
	].! !

!AplicarUnaFuncion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:25'!
tieneUnMetodoConflictivo: unMetodo en: trait
	^trait selectors includes: unMetodo.! !

Object subclass: #EjecutarTodasEnOrden
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!EjecutarTodasEnOrden class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:55'!
CrearEstrategia
	|nuevaEstrategia|
	
	nuevaEstrategia := EjecutarTodasEnOrden new.
	^nuevaEstrategia.! !

!EjecutarTodasEnOrden class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 20:50'!
CrearEstrategiaCon: unaCondicion
	
	|nuevaEstrategia|
	
	nuevaEstrategia := EjecutarTodasEnOrden new.
	nuevaEstrategia condicion: unaCondicion.
	^nuevaEstrategia.! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 14:43'!
argumentosDe: codigo
	
	| palabrasPrimeraLinea |
	
	palabrasPrimeraLinea := (codigo lineCorrespondingToIndex: 1) substrings.
	
	^palabrasPrimeraLinea reject: [ :palabra | palabra endsWith: ':'].! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 16:53'!
armarWithsDe: argumentos
	
	^ (argumentos collect: [ :argumento  | 'with: ' ,argumento  ] ) inject: '' into: [ :frase :argumento | frase,' ',argumento ].! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 20:51'!
condicion
	^condicion.! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 20:51'!
condicion: unaCondicion 
	condicion := unaCondicion.! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 13:47'!
obtenerTraitsConflictivosEn: unaClase para: unMetodo

	| traitConflictivos |
	
	traitConflictivos  := Set new.
	
	traitConflictivos addAll: ( unaClase traits select: [ :trait | self tieneUnMetodoConflictivo: unMetodo en: trait ] ).	
	
	^traitConflictivos! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
resolverConflictoPara: unMetodo entre: unTrait y: unaClase

	| codigoOriginal conflictivos withsArmados |
	
	( unaClase selectors includes: ('original',unMetodo ) ) ifFalse: 
	[
		codigoOriginal := (unaClase >> unMetodo) sourceCode.
	
		withsArmados := (EjecutarTodasEnOrden new) armarWithsDe: (self argumentosDe: codigoOriginal).

		unaClase compile: 'original',codigoOriginal.
	
		unaClase compile:
		( (unaClase >> unMetodo) sourceCode lineCorrespondingToIndex: 1),'
			| conflictivos retorno argumentos withsArmados|
	
			argumentos := (EjecutarTodasEnOrden new) argumentosDe: ( (self class >> #original',unMetodo,' ) sourceCode ).
		
			conflictivos := ( (EjecutarTodasEnOrden new) obtenerTraitsConflictivosEn: self class para: #',unMetodo,' ). 
		
			retorno := self perform: #original',unMetodo,' ',withsArmados,'.
		
			retorno := conflictivos inject: retorno into: [ :resultado :implementador | (self class) methodDict at: #auxiliar put: (implementador >> #',unMetodo,') . 
				     																	    self perform: #auxiliar with: resultado ].
			(self class) methodDict at: #auxiliar put: nil.
		
			^retorno.
			'
	].! !

!EjecutarTodasEnOrden methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 13:11'!
tieneUnMetodoConflictivo: unMetodo en: trait
	^trait selectors includes: unMetodo.! !

Object subclass: #EstrategiaBasica
	instanceVariableNames: 'funcion condicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!EstrategiaBasica class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 00:06'!
CrearEstrategiaConCondicion: unaCondicion yFuncion: unaFuncion
	
	| nuevaEstrategia |
	
	nuevaEstrategia := EstrategiaBasica new.
	nuevaEstrategia condicion: unaCondicion.
	nuevaEstrategia funcion: unaFuncion.
	^nuevaEstrategia.! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:57'!
aplicarFuncion: unValor 
	^funcion value: unValor.! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:30'!
argumentosDe: codigo
	
	| palabrasPrimeraLinea |
	
	palabrasPrimeraLinea := (codigo lineCorrespondingToIndex: 1) substrings.
	
	^palabrasPrimeraLinea reject: [ :palabra | palabra endsWith: ':'].! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:30'!
armarWithsDe: argumentos
	
	^ (argumentos collect: [ :argumento  | 'with: ' ,argumento  ] ) inject: '' into: [ :frase :argumento | frase,' ',argumento ].! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:29'!
condicion
	^condicion ! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:56'!
condicion: unBloqueCondicion
	condicion := unBloqueCondicion  .! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:57'!
cumpleCondicion: unValor
	^condicion value: unValor.
	! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 00:57'!
ejecutarTodosLosMetodosDeTraitsCorrespondientesA: unMetodo dentroDe: unObjeto conUnValorInicial: unValor

			| conflictivos retorno  |
			
			conflictivos := ( self obtenerTraitsConflictivosEn: (unObjeto class) para: unMetodo). 
		
			retorno := conflictivos inject: unValor into: 
			[ :resultado :implementador | 
				(self cumpleCondicion: retorno) ifFalse: [^resultado].
				(unObjeto class) methodDict at: #auxiliar put: (implementador >> unMetodo) . 
				unObjeto perform: #auxiliar with: resultado 
			].
			(unObjeto class) methodDict at: #auxiliar put: nil.
		
			^self aplicarFuncion: retorno.! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:29'!
funcion
	^funcion.! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:56'!
funcion: unBloqueFuncion "Una funcion es un cdigo a compilar"
	funcion := unBloqueFuncion.! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:30'!
obtenerTraitsConflictivosEn: unaClase para: unMetodo

	| traitConflictivos |
	
	traitConflictivos  := Set new.
	
	traitConflictivos addAll: ( unaClase traits select: [ :trait | self tieneUnMetodoConflictivo: unMetodo en: trait ] ).	
	
	^traitConflictivos! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 00:51'!
resolverConflictoPara: unMetodo entre: unTrait y: unaClase

	| codigoOriginal withsArmados |
	
	( unaClase selectors includes: ('original',unMetodo ) ) ifFalse: 
	[
		codigoOriginal := (unaClase >> unMetodo) sourceCode.
	
		withsArmados := (EjecutarTodasEnOrden new) armarWithsDe: (self argumentosDe: codigoOriginal).

		unaClase compile: ( (unaClase >> unMetodo ) getSourceReplacingSelectorWith: 'original',unMetodo ).
		
		unaClase addInstVarNamed: 'refactor'.
		
		unaClase compile: 
		( (unaClase >> unMetodo) sourceCode lineCorrespondingToIndex: 1),'
			
			|  retorno |
			
			refactor := EstrategiaBasica CrearEstrategiaConCondicion: ', condicion asString ,' yFuncion: ', funcion asString ,'.
			
			retorno := self perform: #original',unMetodo,' ',withsArmados,'.
		
			retorno := refactor ejecutarTodosLosMetodosDeTraitsCorrespondientesA: #',unMetodo,' dentroDe: self conUnValorInicial: retorno .
			
			^retorno.
			'
	].! !

!EstrategiaBasica methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 23:31'!
tieneUnMetodoConflictivo: unMetodo en: trait
	^trait selectors includes: unMetodo.! !

EstrategiaBasica subclass: #EstrategiaConCondicion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!EstrategiaConCondicion class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 00:39'!
CrearEstrategiaConCondicion: unaCondicion
	^self superclass CrearEstrategiaConCondicion: unaCondicion yFuncion: [ :x | x ].! !

!EstrategiaConCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 00:23'!
CrearEstrategiaConCondicion: unaCondicion
	^self superclass CrearEstrategiaConCondicion: unaCondicion yFuncion: [ :x | x ].! !

EstrategiaBasica subclass: #EstrategiaConFuncion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!EstrategiaConFuncion class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 00:24'!
CrearEstrategiaConFuncion: unaFuncion
	^EstrategiaBasica CrearEstrategiaConCondicion: [ :x | true ] yFuncion: unaFuncion.! !

EstrategiaBasica subclass: #EstrategiaDefault
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!EstrategiaDefault class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/4/2013 00:20'!
CrearEstrategiaDefault
		^EstrategiaBasica CrearEstrategiaConCondicion: [ :x | true ] yFuncion: [ :x | x ]! !

Object subclass: #ExaminarCondicion
	instanceVariableNames: 'condicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!ExaminarCondicion class methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:51'!
CrearEstrategiaCon: unaCondicion
	
	|nuevaEstrategia|
	
	nuevaEstrategia := ExaminarCondicion new.
	nuevaEstrategia condicion: unaCondicion.
	^nuevaEstrategia.! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
argumentosDe: codigo
	
	| palabrasPrimeraLinea |
	
	palabrasPrimeraLinea := (codigo lineCorrespondingToIndex: 1) substrings.
	
	^palabrasPrimeraLinea reject: [ :palabra | palabra endsWith: ':'].! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
armarWithsDe: argumentos
	
	^ (argumentos collect: [ :argumento  | 'with: ' ,argumento  ] ) inject: '' into: [ :frase :argumento | frase,' ',argumento ].! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
condicion
	^condicion.! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
condicion: unaCondicion 
	condicion := unaCondicion.! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
obtenerTraitsConflictivosEn: unaClase para: unMetodo

	| traitConflictivos |
	
	traitConflictivos  := Set new.
	
	traitConflictivos addAll: ( unaClase traits select: [ :trait | self tieneUnMetodoConflictivo: unMetodo en: trait ] ).	
	
	^traitConflictivos! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:40'!
resolverConflictoPara: unMetodo entre: unTrait y: unaClase

	| codigoOriginal conflictivos withsArmados |
	
	( unaClase selectors includes: ('original',unMetodo ) ) ifFalse: 
	[
		codigoOriginal := (unaClase >> unMetodo) sourceCode.
	
		withsArmados := (EjecutarTodasEnOrden new) armarWithsDe: (self argumentosDe: codigoOriginal).

		unaClase compile: 'original',codigoOriginal.
	
		unaClase compile:
		( (unaClase >> unMetodo) sourceCode lineCorrespondingToIndex: 1),'
			| conflictivos retorno argumentos withsArmados|
	
			argumentos := (ExaminarCondicion new) argumentosDe: ( (self class >> #original',unMetodo,' ) sourceCode ).
		
			conflictivos := ( (ExaminarCondicion new) obtenerTraitsConflictivosEn: self class para: #',unMetodo,' ). 
		
			retorno := self perform: #original',unMetodo,' ',withsArmados,'.
		
			retorno := conflictivos inject: retorno into: [ :resultado :implementador |
				(resultado ',self condicion,' ) ifFalse: [^resultado].
				(self class) methodDict at: #auxiliar put: (implementador >> #',unMetodo,') . 
				self perform: #auxiliar with: resultado 
			].
			(self class) methodDict at: #auxiliar put: nil.
		
			^retorno.
			'
	].! !

!ExaminarCondicion methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 21:26'!
tieneUnMetodoConflictivo: unMetodo en: trait
	^trait selectors includes: unMetodo.! !

Object subclass: #Refactor3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Parte3'!

!Refactor3 methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/3/2013 17:49'!
agregarTrait: unTrait a: unaClase con: unaEstrategia
	
	|metodosConflictivos|
	
	( unaClase traits includes: unTrait ) ifFalse: 
	[
		unaClase addToComposition: unTrait.
	
		metodosConflictivos := unTrait selectors select: [ :selector | self esConflitivo: selector en: unaClase ].
	
		metodosConflictivos do: [ :selector | unaEstrategia resolverConflictoPara: selector entre: unTrait  y: unaClase ].
	]! !

!Refactor3 methodsFor: 'as yet unclassified' stamp: 'LucasCostas 5/2/2013 00:19'!
esConflitivo: unSelector en: unaClase
	|traits|
	
	traits := unaClase traits.
	
	^ (unaClase selectors includes: unSelector) | ( traits notEmpty and: [ traits anySatisfy: [ :unTrait | self esConflitivo: unSelector en: unTrait ] ] ). 
	
	"Mejorar TODO"! !
